//--------------------------------------------------------------------------//
// xmtnimage17.cc                                                           //
// Latest revision: 09-06-2023                                              //
// See xmtnimage.h for Copyright Notice                                     //
//--------------------------------------------------------------------------//

#include "xmtnimage.h"
#define __USE_POSIX2 1
#define __USE_SVID 1
extern Globals     g;
extern Image      *z;
extern int         ci;
struct Cui
{   short uint off;
    int *var;
    int bytes;
    int def;
};
int noofoffsets=21;               // Change this if adding a new offset



//--------------------------------------------------------------------------//
// cui_cmp - for qsort                                                      //
//--------------------------------------------------------------------------//
int cui_cmp(const void *p, const void *q)
{
   return sgn(((Cui*)p)->off - ((Cui*)q)->off);
}




//--------------------------------------------------------------------------//
// ushorttoa                                                                //
//--------------------------------------------------------------------------//
void ushorttoa(unsigned short i, char* a)
{
  itoa(i,a,10);
  if(!strcmp(a,"-1")) strcpy(a,"-1");
}





//--------------------------------------------------------------------------//
// list_match                                                               //
//--------------------------------------------------------------------------//
int list_match(char **list, char *string, int n)
{
    int k=0;
    for(k=0;k<n;k++) if(!strcmp(string,list[k])) return k;
    return 0;
}



//--------------------------------------------------------------------------//
//  compress_file                                                           //
//--------------------------------------------------------------------------//
int compress_file(char *filename, char *compressor, char *ext)
{
   int status=0;
   char tempstring[2*FILENAMELENGTH];
   char newfilename[FILENAMELENGTH];
   if(access(compressor,X_OK))
   {    sprintf(tempstring, "Cannot execute %s\nfile was not compressed",compressor); 
        message(tempstring);
        return NOTFOUND;
   }
   if(!strlen(filename)){ message("No filename - cant compress file"); return ERROR; }
   if(!strlen(compressor)){ message("No compression utility specified"); return ERROR; }
   if(!strlen(ext)){ message("No compression extension specified"); return ERROR; }
   sprintf(tempstring, "%s %s", compressor, filename);
   sprintf(newfilename, "%s%s", filename, ext);
   status = system(tempstring);
   if(status==127 || status == -1)
        sprintf(tempstring, "Error executing /bin/sh -c %s %s",compressor,filename);  
   if(!access(newfilename,F_OK))  // File exists
        sprintf(tempstring, 
        "File successfully compressed by\n%s\nFilename changed to\n%s",
        compressor, newfilename);
   else strcpy(tempstring,"Error compressing image file");
   message(tempstring);
   return status;   
}



//--------------------------------------------------------------------------//
// open_file                                                                //
// filename has to be a complete path to use access()                       //
//--------------------------------------------------------------------------//
FILE *open_file(char *filename, const char *rwmode)
{
   errno = 0;
   char tempstring[FILENAMELENGTH];
   FILE *fp;
   if((fp=fopen(filename, rwmode)) == NULL)
   {   sprintf(tempstring, "Can't create file %s\nerrno = %d", filename, errno);
       message(tempstring, ERROR);    
       return (FILE*)NULL; 
   }
   return fp;
}


//--------------------------------------------------------------------------//
// close_file                                                               //
//--------------------------------------------------------------------------//
int close_file(FILE *fp)
{
  fclose(fp);
  return OK;
}
