//--------------------------------------------------------------------------//
// xmtnimage47.cc                                                           //
// Latest revision: 05-05-2008                                              //
// See xmtnimage.h for Copyright Notice                                     //
// warp                                                                     //
//--------------------------------------------------------------------------//

#include "xmtnimage.h"

extern Globals     g;
extern Image      *z;
extern int         ci;
int ***ggg;
int newino, nnnx, nnny;
int in_warp = 0;
int in_warp2d = 0;
int warp_direction = 1;

//-------------------------------------------------------------------------//
// warp                                                                    //
// Change shape of image                                                   //
//-------------------------------------------------------------------------//
void warp(void)
{
  static Dialog *dialog;
  int j,k;
  if(in_warp) return;
  dialog = new Dialog;
  if(dialog==NULL){ message(g.nomemory); in_warp = 0; return; }
  in_warp = 1;
  strcpy(dialog->title,"Warping");

  //-----Dialog box to get title & other options------------//

  strcpy(dialog->radio[0][0],"Operation");
  strcpy(dialog->radio[0][1],"1-D warp");
  strcpy(dialog->radio[0][2],"2-D warp");
  strcpy(dialog->radio[0][3],"Fix barrel/pincushion");
  strcpy(dialog->radio[0][4],"Restore original");
  dialog->radiono[0]=5;
  dialog->radioset[0] = -1;

  strcpy(dialog->radio[1][0],"Direction");
  strcpy(dialog->radio[1][1],"Vertical");
  strcpy(dialog->radio[1][2],"Horizontal");
  dialog->radiono[1]=3; 
  dialog->radioset[1] = warp_direction;

  for(j=0;j<10;j++) for(k=0;k<20;k++) dialog->radiotype[j][k]=RADIO;  

  strcpy(dialog->boxes[0],"2D Warp Parameters");
  dialog->boxtype[0]=LABEL;

  strcpy(dialog->boxes[1],"Pixels/grid point");
  dialog->boxtype[1]=INTCLICKBOX;
  sprintf(dialog->answer[1][0], "%d", g.warp_gridpoints);
  dialog->boxmin[1]=2; dialog->boxmax[1]=400;

  strcpy(dialog->boxes[2],"Select group of points");
  dialog->boxtype[2]=TOGGLE;
  dialog->boxset[2]=0;   

  strcpy(dialog->boxes[3],"Cursor movement");
  dialog->boxtype[3]=INTCLICKBOX;
  sprintf(dialog->answer[3][0], "%d", g.warp_cursor);
  dialog->boxmin[3]=1; dialog->boxmax[3]=100;

  strcpy(dialog->boxes[4],"Grid visible");
  dialog->boxtype[4]=TOGGLE;
  dialog->boxset[4] = g.grid_visible;
  
  dialog->want_changecicb = 0;
  dialog->f1 = warpcheck;
  dialog->f2 = null;
  dialog->f3 = null;
  dialog->f4 = warpfinish;
  dialog->f5 = null;
  dialog->f6 = null;
  dialog->f7 = null;
  dialog->f8 = null;
  dialog->f9 = null;
  dialog->width = 0;  // calculate automatically
  dialog->height = 0; // calculate automatically
  dialog->noofradios = 2;
  dialog->noofboxes = 5;
  dialog->helptopic = 65;
  dialog->transient = 1;
  dialog->wantraise = 0;

  //// Use a custom format dialog box
  dialog->radiousexy = 0;
  dialog->boxusexy = 0;
  dialog->radioextrawidth = 0;
  strcpy(dialog->path, ".");
  strcpy(dialog->message, " ");      
  dialog->message_x1 = 160;
  dialog->message_y1 =  98;
  strcpy(dialog->message2, "");      
  dialog->message_x2 =   0;
  dialog->message_y2 =   0;
  dialog->busy = 0;
  dialogbox(dialog);
  return;
}


//--------------------------------------------------------------------------//
//  warpfinish                                                              //
//--------------------------------------------------------------------------//
void warpfinish(dialoginfo *a)
{
   a=a;
   in_warp = 0;
   printstatus(NORMAL);
   XFlush(g.display);
}



//--------------------------------------------------------------------------//
//  warpcheck                                                               //
//--------------------------------------------------------------------------//
void warpcheck(dialoginfo *a, int radio, int box, int boxbutton)
{
   static int inwarpcheck=0;
   if(inwarpcheck) return;  //// XtSetValues->dialogstringcb->fftcheck
   warp_direction = a->radioset[1];
   inwarpcheck=1;
   box=box; boxbutton=boxbutton;
   g.warp_gridpoints = atoi(a->answer[1][0]);
   g.warp_cursor = atoi(a->answer[3][0]);
   if(a->boxwidget[2][0]) setsensitive(a->boxwidget[2][0], False);

   if(radio==0) switch(a->radioset[0])
   {
        case 1: warp1d(warp_direction); break;
        case 2: 
                setsensitive(a->boxwidget[2][0], True);
                dialog_message((char*)"Press Esc when finished");
                warp2d(a, g.warp_gridpoints, g.warp_gridpoints,1,0,0,0,0);
                dialog_message((char*)"");
                break;
        case 3: 
                setsensitive(a->boxwidget[2][0], False);
                dialog_message((char*)"Press Esc when finished");
                warp2d(a, z[ci].xsize/4, z[ci].ysize/4,1,0,0,0,0);
                dialog_message((char*)"");
                break;
        case 4: restoreimage(1); break;
   }
   unset_radio(a, 0);
   inwarpcheck=0;
   XFlush(g.display);
}


//-------------------------------------------------------------------------//
// warp1d                                                                  //
// Change shape of image                                                   //
//-------------------------------------------------------------------------//
void warp1d(int direction)
{
   if(ci<0){  message("Please select an image first\n");  return; }
   if(z[ci].floating) return;
   if(memorylessthan(16384)){  message(g.nomemory,ERROR); return; } 
   const int NMAX = 1000;
   int bpp, ino, d=0, i, j, k, xstart=0, xend, x, y, yalign, hindex;
   for(k=0; k<g.image_count; k++) z[k].hit=0;
   uint value;  
  
   XYData data;
   data.x = new int[NMAX]; if(data.x==NULL){ message(g.nomemory,ERROR); return; }
   data.y = new int[NMAX]; 
          if(data.y==NULL){ delete[] data.x; message(g.nomemory,ERROR); return; }
   data.v = NULL;
   data.n = 0;
   data.dims = 1;
   data.nmin = 0;
   data.nmax = NMAX;
   data.duration = TEMP;
   data.wantpause = 0;
   data.wantmessage = 1;
   if(direction==1)  data.type = 0;  // bezier
   if(direction==2)  data.type = 8;  // sketch
   data.win  = 0; // calculate window automatically on drawing area
 
   for(k=0;k<g.xres;k++) g.highest[k]=0;        // Initialize baseline buf.

   ////  bezier_curve_start() sets bezier_state to CURVE.                    
   ////  When user presses a key to stop the Bezier curve, bezier_curve_end()
   ////  sets bezier_state to 'NORMAL'.                                             
   ////  bezier_curve_end() also deallocates arrays x & y.                        
   ////  User selected curve is put in 1d int array g.highest[].

   bezier_curve_start(&data, NULL);
   g.block++;
   while(g.bezier_state==CURVE)
        XtAppProcessEvent(XtWidgetToApplicationContext(g.drawing_area),XtIMAll);
   g.block = max(0,g.block-1);

   xstart = 0;               // Left x coord of user's Bezier
   xend = g.xres;            // Right x coord of user's Bezier

   for(k=0;k<g.xres;k++) if(g.highest[k]!=0) { xstart=k; break; }
   for(k=g.xres;k>=xstart;k--) if(g.highest[k]!=0) { xend=k; break; }

   ////  Scale user's curve if ci is zoomed
   
   for(k=xstart; k<=xend; k++) 
        g.highest[k] = zoom_y_coordinate(g.highest[k], ci);


   ////  This section warps all the pixels in the selected image. Pixels outside
   ////  the image are  not affected.
   ////  highest[] is the Bezier curve for each x relative to the left of the 
   ////  screen. Subtract main_xpos to get the coordinate for drawing pixels
   ////  (which may be negative).

   if(direction==1)
   {
        message("Click at y value to align to");
        getpoint(x,y);

        yalign = zoom_y_coordinate(y, ci);
        xstart = zoom_x_coordinate(xstart - g.main_xpos - z[ci].xpos, ci);
        xend   = zoom_x_coordinate(xend   - g.main_xpos - z[ci].xpos, ci);
        xstart += z[ci].xpos;
        xend   += z[ci].xpos;

        for(i=xstart; i<=xend; i++)
        {   
            // d is distance to move down
            hindex = zoom_x_coordinate_of_index(i, ci) + g.main_xpos - z[ci].xpos;
            if(g.highest[hindex] == 0) continue;
            d =  yalign - g.highest[hindex];   

            if(d>0)                     // Pixels to be moved down 
            {   for(j=z[ci].ypos+z[ci].ysize-1; j>=z[ci].ypos; j--)
                {   if(j-d >= z[ci].ypos)
                      value = readpixelonimage(i,j-d,bpp,ino);
                    else
                      value = g.bcolor;
                    if(ino>=0)
                    {  if((g.bitsperpixel==8)&&(bpp!=8)&&(z[ino].hitgray==0))
                           z[ino].hit=1;
                       if(!g.wantr || !g.wantg || !g.wantb) z[ino].hit=1;
                       if(bpp==8 || z[ino].colortype==GRAY) z[ino].hit=1;
                    }
                    setpixelonimage(i,j,value,g.imode,bpp);
                }
            }else                       // Pixels to be moved up
            {   for(j=z[ci].ypos;j<z[ci].ysize+z[ci].ypos;j++)
                {   if(j-d < z[ci].ysize+z[ci].ypos)
                       value = readpixelonimage(i,j-d,bpp,ino);
                    else
                       value = g.bcolor;
                    if(ino>=0)
                    {  if((g.bitsperpixel==8)&&(bpp!=8)&&(z[ino].hitgray==0))
                           z[ino].hit=1;
                       if(!g.wantr || !g.wantg || !g.wantb) z[ino].hit=1;
                       if(bpp==8 || z[ino].colortype==GRAY) z[ino].hit=1;
                    }
                    setpixelonimage(i,j,value,g.imode,bpp);
                }
            }
            if(g.getout){ g.getout=0; break;}
        }    
   }else message("Function not implemented");

   g.state=NORMAL;
   g.bezier_state=NORMAL;
   delete[] data.x;
   delete[] data.y;
   for(k=0; k<g.image_count; k++) 
   {  if(z[k].hit)
      { 
           repairimg(k,0,0,z[k].xsize,z[k].ysize); 
           redraw(k); 
      }
   }
  switch_palette(ci);
  rebuild_display(ci); 
  redraw(ci); 
}


//-------------------------------------------------------------------------//
// warp2d                                                                  //
// Change shape of image n = no.of grid points                             //
// if wantnewimage is set to 1, does a simple 2d warp. if 0, it puts       //
// 'refimage' in the background and makes ci transparent so ci can be      //
// manually warped to bring ci and refimage into register.                 //
//-------------------------------------------------------------------------//
void warp2d(dialoginfo *a, int nx, int ny, int wantnewimage, int refimage, 
int wantred, int wantgreen, int wantblue)
{
   wantblue=wantblue;
   if(z[ci].floating) return;
   static int count=0;   
   int want_group=0,owantgreen=0;
   int owantred=0;
   // int owantblue=0;
   want_group = a->boxset[2];
   g.grid_visible = a->boxset[4];
   if(in_warp2d) return;
   in_warp2d=1;
   int f,ino,i,j,k,x1,y1,x2,y2,xx=0,yy=0,xar,yar,need_redraw,
       ulx=0,uly=0,lrx=0,lry=0, dupimage=0, hitgreen=0, hitred=0;
   int ox1 = 0, oy1 = 0, oy2 = 0, oinmenu, otransparency;
   int gxmin,gxmax,gymin,gymax;
   ino = ci;
   if(!between(ino, 1, g.image_count-1)){ in_warp2d=0; return; }
   int xsize = z[ino].xsize;
   int ysize = z[ino].ysize;
   int xpos = z[ino].xpos;
   int ypos = z[ino].ypos;
   int newxpos;
   int newypos;
   int size;
   char title[100];
   int c;
   void (*oldexposefunc)(void *) = NULL;  
   uchar temp[4];
   uint keysym=0;

   f = z[ino].cf;
   newino = ci;
   xar = xsize/nx+1;
   yar = ysize/ny+1;
   array<int> grid(xar+1, yar+1, 2);
   if(!grid.allocated){ message(g.nomemory); in_warp2d=0; return; }
   array<int> selected_point(xar+1, yar+1);
   if(!selected_point.allocated){ message(g.nomemory); in_warp2d=0; return; }
   ggg = grid.q;
   nnnx = nx;
   nnny = ny;
   g.key_ascii = 0;

   initialize_grid(grid.q, xar, yar, nx, ny);
   initialize_selected_point(selected_point.p, xar, yar);
   otransparency = z[ino].transparency; 
   g.warp_transparency = atoi(a->answer[5][0]);

   //// Must make a copy of image so warping will work
   if(wantnewimage)
   {     newxpos = xpos + 100;
         newypos = ypos + 100;
         message("Drag grid points to destination\nto define the coordinate mapping.\nClick Cancel when ready");
         duplicate_image(ino, newxpos, newypos, g.want_shell, g.window_border);
         if(g.autoundo) backupimage(ci, 0);
  }else
   {     message("Select areas, then drag to warp image.\nClick Cancel when finished");
         newxpos = xpos;
         newypos = ypos;
         duplicate_image(ino, newxpos, newypos, g.want_shell, g.window_border);
         if(g.autoundo) backupimage(ci, 0);
         dupimage = ci;
         z[refimage].transparency = 0;
         z[dupimage].transparency = g.warp_transparency;
         switchto(refimage);   // put refimage 2nd from top

         if(wantgreen){ make_image_green(refimage); hitgreen=1; }
         if(wantred  ){ make_image_red(dupimage); hitred  =1; }
         if(wantblue ){ make_image_blue(dupimage); }
         if(wantgreen) redraw(refimage); // redraw it so is green
         switchto(dupimage);   // put dupimage on top
         redraw(dupimage);     // redraw it so transparency is correct
   }

   setimagetitle(ci,"Warped");
   z[ci].touched = 1;
   newino = ci;

   g.getout = 0;
   if(!between(ino, 1, g.image_count-1)){ in_warp2d=0; return; }
   draw_grid(NULL);  
   g.busy++;
   oinmenu = g.inmenu;
   oldexposefunc = z[newino].exposefunc; 
   while(!g.getout)
   {    g.inmenu++;  
        check_event();
        g.warp_cursor = atoi(a->answer[3][0]);
        g.grid_visible = a->boxset[4];
        otransparency = g.warp_transparency;
        g.warp_transparency = atoi(a->answer[5][0]);
        z[dupimage].transparency = g.warp_transparency;

        wantgreen = a->boxset[6];
        if(wantgreen != owantgreen)
        {   if(wantgreen)
            {    if(z[refimage].bpp==8){ make_image_green(refimage); hitgreen=1; }
            }else    
            {    if(z[refimage].bpp==8)
                 {    converttograyscale(refimage);
                      rebuild_display(refimage);
                 }
            }
            owantgreen = wantgreen;
        }

        wantred = a->boxset[7];
        if(wantred != owantred)
        {   if(wantred)
            {    if(z[dupimage].bpp==8){ make_image_red(dupimage); hitred=1; }
            }else    
            {    if(z[dupimage].bpp==8)
                 {    converttograyscale(dupimage);
                      rebuild_display(dupimage);
                 }
            }
            owantred = wantred;
        }
        
        if(g.warp_transparency != otransparency)
        {   rebuild_display(dupimage);
            redraw(dupimage);
        }
        if(g.grid_visible && between(newino, 0, g.image_count-1))
        { 
            z[newino].exposefunc = draw_grid; 
        }
        ox1 = x1; oy1 = y1; oy2 = y2;
        want_group = a->boxset[2];
        g.grid_visible = a->boxset[4];
        want_group = a->boxset[2];
        initialize_selected_point(selected_point.p, xar, yar);

        g.want_switching = 0;  // stop it from selecting entire image when user clicks
        if(want_group)
        {   dialog_message((char*)"Select group of points");
            getbox(ulx,uly,lrx,lry);  // Event can occur here, must check for change in state
            if(want_group) drawselectbox(ON); else drawselectbox(OFF);
            check_event();
            want_group = a->boxset[2];
            dialog_message((char*)"Drag group to new location");
            g.selected_ulx = g.get_x1;
            g.selected_uly = g.get_y1;
            g.selected_lrx = g.get_x2;
            g.selected_lry = g.get_y2;
            if(g.getout) break;
        }else
            dialog_message((char*)"Drag point to new location");

      //  getline_crawling_boxes_on(x1,y1,x2,y2); // Event can occur here, must check for change in state
        getline(x1,y1,x2,y2); // Event can occur here, must check for change in state
        g.want_switching = 1;
        if(g.getout) break;
        dialog_message((char*)"Press Esc when finished");
        if(!between(ci,     0, g.image_count-1) ||
           !between(newino, 0, g.image_count-1) || 
           !between(ino,    0, g.image_count-1)) 
        {   g.inmenu=oinmenu; g.getout=0; g.busy=max(0,g.busy-1); in_warp2d=0; message("Missing image",ERROR); return; }
        if(ci != newino) switchto(newino);

        need_redraw = 0;
        if(!g.grid_visible) 
        {    z[newino].exposefunc = oldexposefunc; 
        }
        newxpos = z[newino].xpos;                         // Recalculate in case 
        newypos = z[newino].ypos;                         // image was moved

        x1 -= newxpos; y1 -= newypos;
        x2 -= newxpos; y2 -= newypos;
        ulx -= newxpos; uly -= newypos;
        lrx -= newxpos; lry -= newypos;
        g.inmenu = oinmenu;
        if(g.getout) break;
                                                          // Grid point to move
                                                          // xx,yy = closest point
        if((x1!=ox1 || y1!=oy1 || y2!=oy2 || y2!=oy2) ||  // A line was selected  (not a keypress)
           (x1!=x2  || y1!= y2))                          // A line of nonzero length (not a point) 
        {  
           if(want_group)
               find_selected_point(selected_point.p, newino, ulx, uly, lrx, lry, xar, yar, 
                              gxmin, gymin, gxmax, gymax); 
           else
               find_closest_point(grid.q, newino, x1, y1, xar, yar, nx, ny, xx, yy, 
                              gxmin, gymin, gxmax, gymax); 
        }

        if((x1!=ox1 || y1!=oy1 || y2!=oy2 || y2!=oy2) &&  // A line was selected (not a keypress)
           (x1!=x2  || y1!= y2))                          // A line of nonzero length (not a point)
        {      
           if(want_group)
           {    for(j=0; j<yar; j++)
                for(i=0; i<xar; i++)
                if(selected_point.p[j][i])
                {   grid.q[0][j][i] += x2-x1;               // Set new grid point
                    grid.q[1][j][i] += y2-y1;  
                    need_redraw = 1;
                }
           }else
           {   if(between(xx,0,xar) && between(yy,0,yar))
               {   grid.q[0][yy][xx] = x2;                    // Set new grid point
                   grid.q[1][yy][xx] = y2;  
                   need_redraw = 1;
               }
           }
        }

        c = 0;
        c = getcharacter(); 
        g.key_ascii = 0;                                  // get rid of keystroke
        temp[1] = c & 0xff;
        temp[0] = 255;
        keysym = (uint)temp[0]*256 + (uint)temp[1];
        XSync(g.display, 0);

        ////  Single character commands for user to type while warping
        switch(c)
        {  case 'r':                                      // restore original grid
                initialize_grid(grid.q, xar, yar, nx, ny);
                remap_coordinates(ino, f, newino, grid.q, 0, 0, xar-1, yar-1, nx, ny);
                x1=x2=newxpos;
                y1=y2=newypos;
                repair(newino);
                redraw(newino);
                break;
           case 'g':
                g.grid_visible = 1 - g.grid_visible;
                a->boxset[4] = 1 - a->boxset[4];
                gxmin=gymin=0;
                gxmax=xar;
                gymax=yar;
                break;
           case 'c':
                if(!between(newino, 0, g.image_count-1))
                {   message("Missing image",ERROR); g.getout=0; in_warp2d=0; g.busy=max(0,g.busy-1); return; }
                duplicate_image(newino, newxpos+20, newypos+20, g.want_shell, 
                   g.window_border);
                switchto(newino);
                if(g.getout) break;
                break;
           case 27:
                g.getout=1;
        }
        switch(keysym)
        {
           case XK_Left:  grid.q[0][yy][xx]-=g.warp_cursor; break;
           case XK_Right: grid.q[0][yy][xx]+=g.warp_cursor; break;
           case XK_Up:    grid.q[1][yy][xx]-=g.warp_cursor; break;
           case XK_Down:  grid.q[1][yy][xx]+=g.warp_cursor; break;     
        }
        if(need_redraw || c) 
        {   remap_coordinates(ino, f, newino, grid.q, gxmin, gymin, gxmax, gymax, nx, ny);
            repair(newino);
        }
        c = 0;
   }
   in_warp2d=0;
   z[newino].exposefunc = NULL;
   repair(newino);
   if(g.autoundo) backupimage(newino, 0); 
   sprintf(title, "warped_%d", ++count);
   setimagetitle(newino, title);
   z[newino].touched = 1;
   switchto(newino);
   g.getout = 0;
   g.busy=max(0,g.busy-1);
   g.inmenu=oinmenu;
   g.want_switching = 1;
   if(!wantnewimage) z[ino].transparency = otransparency;
   z[ci].transparency = 0;
   rebuild_display(dupimage);

   if(hitgreen)
   {   converttograyscale(refimage);
       rebuild_display(refimage);
   }
   if(hitred)
   {   converttograyscale(dupimage);
       rebuild_display(dupimage);
   }

   //// put in globals so they can re-warp another one
   if(g.warp_grid_allocated) free(g.warp_grid);
   g.warp_nx = nx;
   g.warp_ny = ny;
   g.warp_xar = xar;
   g.warp_yar = yar;
   size = 2 * (g.warp_xar+1) * (g.warp_yar+1);
   g.warp_grid = (int*)malloc(size * sizeof(int));
   g.warp_grid_allocated = 1;
   if(g.warp_grid == NULL) { message(g.nomemory,ERROR); g.warp_grid_allocated=0;}
   else 
   {   count = 0;
       for(i=0; i<2; i++)
       for(j=0; j<=yar; j++)
       for(k=0; k<=xar; k++)
          g.warp_grid[count++] = grid.q[i][j][k];
    }
   return;
}


//-------------------------------------------------------------------------//
// make_image_red                                                          //
//-------------------------------------------------------------------------//
void make_image_red(int ino)
{
    int k;
    if(!between(ino, 0, g.image_count - 1)) return; 
    if(z[ino].colortype==INDEXED)
    {
        for(k=0;k<255;k++)
        {    z[ino].palette[k].red =  64-k/4; 
             z[ino].palette[k].green = 0; 
             z[ino].palette[k].blue = 0; 
        }
        memcpy(g.palette, z[ino].palette, 768);
        memcpy(z[ino].opalette, g.palette, 768);
        memcpy(z[ino].spalette, g.palette, 768);
        rebuild_display(ino);  
        redraw(ino);
    }else 
    {   z[ino].want_red = 1;
        z[ino].want_blue = 0;
        z[ino].want_green = 0;
        rebuild_display(ino);  
        redraw(ino);
    }
}
//-------------------------------------------------------------------------//
// make_image_green                                                        //
//-------------------------------------------------------------------------//
void make_image_green(int ino)
{
    int k;
    if(!between(ino, 0, g.image_count - 1)) return; 
    if(z[ino].colortype==INDEXED)
    {
        for(k=0;k<255;k++)
        {    z[ino].palette[k].red =  0; 
             z[ino].palette[k].green = 64-k/4; 
             z[ino].palette[k].blue = 0; 
        }
        memcpy(g.palette, z[ino].palette, 768);
        memcpy(z[ino].opalette, g.palette, 768);
        memcpy(z[ino].spalette, g.palette, 768);
    }else 
    {   z[ino].want_red = 0;
        z[ino].want_green = 1;
        z[ino].want_blue = 0;
    }
    rebuild_display(ino);  
    redraw(ino);
}

//-------------------------------------------------------------------------//
// make_image_blue                                                         //
//-------------------------------------------------------------------------//
void make_image_blue(int ino)
{
    int k;
    if(!between(ino, 0, g.image_count - 1)) return; 
    if(z[ino].colortype==INDEXED)
    {
        for(k=0;k<255;k++)
        {    z[ino].palette[k].red =  0; 
             z[ino].palette[k].green = 0; 
             z[ino].palette[k].blue = 64-k/4; 
        }
        memcpy(g.palette, z[ino].palette, 768);
        memcpy(z[ino].opalette, g.palette, 768);
        memcpy(z[ino].spalette, g.palette, 768);
    }else 
    {   z[ino].want_red = 0;
        z[ino].want_green = 0;
        z[ino].want_blue = 1;
    }
    rebuild_display(ino);  
    redraw(ino);
}

//-------------------------------------------------------------------------//
// make_image_gray                                                         //
//-------------------------------------------------------------------------//
void make_image_gray(int ino)
{
    if(!between(ino, 0, g.image_count - 1)) return; 
    int k;
    if(z[ino].colortype==INDEXED)
    {
        for(k=0;k<255;k++)
        {    z[ino].palette[k].red =  64-k/4; 
             z[ino].palette[k].green = 64-k/4; 
             z[ino].palette[k].blue = 64-k/4; 
        }
        memcpy(g.palette, z[ino].palette, 768);
        memcpy(z[ino].opalette, g.palette, 768);
        memcpy(z[ino].spalette, g.palette, 768);
    }else 
    {   z[ino].want_red = 1;
        z[ino].want_green = 1;
        z[ino].want_blue = 1;
    }
    rebuild_display(ino);  
    redraw(ino);
}

//-------------------------------------------------------------------------//
// initialize_grid                                                         //
//-------------------------------------------------------------------------//
void initialize_grid(int ***g, int xar, int yar, int nx, int ny)
{
   if(!in_warp) return;
   int i,j;
   for(j=0;j<=yar;j++)
   for(i=0;i<=xar;i++)
   {
      g[0][j][i] = i*nx;  // x coord
      g[1][j][i] = j*ny;  // y coord
   }
}

//-------------------------------------------------------------------------//
// initialize_selected_point                                               //
//-------------------------------------------------------------------------//
void initialize_selected_point(int **s, int xar, int yar)
{
   if(!in_warp) return;
   int i,j;
   for(j=0;j<=yar;j++)
   for(i=0;i<=xar;i++) s[j][i] = 0;
}


//-------------------------------------------------------------------------//
// find_closest_point                                                      //
//-------------------------------------------------------------------------//
void find_closest_point(int ***grid, int ino, int x, int y, int xar, int yar, 
     int nx, int ny, int &xclosest, int &yclosest, int &gxmin, int &gymin, int &gxmax, 
     int &gymax)
{
   if(!in_warp) return;
   if(!between(ino, 1, g.image_count-1)) return; 
   int d,i,j,cd;
   int dx = z[ino].xsize / nx;
   int dy = z[ino].ysize / ny;
   xclosest = (x+nx/2)/nx;  // first approx. is unmoved point
   yclosest = (y+ny/2)/ny;       
   cd = (x-xclosest)*(x-xclosest) + (y-yclosest)*(y-yclosest);
   for(j=0;j<yar;j++)
   for(i=0;i<xar;i++)
   {
      d = (x-grid[0][j][i]) * (x-grid[0][j][i]) + 
          (y-grid[1][j][i]) * (y-grid[1][j][i]);        
      if(d<cd){ xclosest=i; yclosest=j; cd=d;}
   }

   ////  Find minimum & maximum grid coordinates to redraw
   gxmin = gxmax = xclosest;
   gymin = gymax = yclosest;
   for(j=0;j<yar;j++)
   for(i=0;i<xar;i++)
   {
       if(i<=gxmin && (x <= dx*i)) gxmin = i;
       if(i>=gxmax && (x >= dx*i)) gxmax = i;
       if(j<=gymin && (y <= dy*j)) gymin = j;
       if(j>=gymax && (y >= dy*j)) gymax = j;
   }
   gxmin = max(0,gxmin-1);
   gymin = max(0,gymin-1);
   gxmax = min(xar,gxmax+1);
   gymax = min(yar,gymax+1);
}


//-------------------------------------------------------------------------//
// find_selected_point                                                     //
//-------------------------------------------------------------------------//
void find_selected_point(int **selected_point, int ino, int x1, int y1, int x2, int y2, 
     int xar, int yar, int &gxmin, int &gymin,  int &gxmax, int &gymax)
{
   if(!in_warp) return;
   if(!between(ino, 1, g.image_count-1)) return; 
   int i,j;
   int dx = z[ino].xscreensize / xar;
   int dy = z[ino].yscreensize / yar;
   x1 = zoom_x_coordinate(x1, ino);
   y1 = zoom_y_coordinate(y1, ino);
   x2 = zoom_x_coordinate(x2, ino);
   y2 = zoom_y_coordinate(y2, ino);
   gxmin = xar; gxmax = 0;
   gymin = yar; gymax = 0;
   for(j=0;j<yar;j++)
   for(i=0;i<xar;i++)
   {
      if(between(i*dx, x1, x2) && between(j*dy, y1, y2))
             selected_point[j][i] = 1;
      gxmin = min(gxmin, i);
      gymin = min(gymin, j);
      gxmax = max(gxmax, i);
      gymax = max(gymax, j);
   }
}


//-------------------------------------------------------------------------//
// draw_grid                                                               //
//-------------------------------------------------------------------------//
void draw_grid(void *ptr)
{
   if(!in_warp) return;
   if(!g.grid_visible) return;
   ptr = ptr;
   int nx = nnnx;
   int ny = nnny;
   int ino = newino;
   if(!between(ino, 1, g.image_count-1)) return; 
   int i,j,x1,y1,x2,y2,xe,ye;
   int xsize = z[ino].xsize;
   int ysize = z[ino].ysize;
   xe = 0;
   ye = 0;

   g.inmenu++;
   for(j=0;j<=ysize/ny;j++)
   for(i=1;i<=xsize/nx;i++)
   {  x1 = ggg[0][j][i-1];
      x2 = ggg[0][j][i  ];
      y1 = ggg[1][j][i-1];
      y2 = ggg[1][j][i  ];
      x1 = cint((double)x1 * z[ino].zoomx);
      x2 = cint((double)x2 * z[ino].zoomx);
      y1 = cint((double)y1 * z[ino].zoomy);
      y2 = cint((double)y2 * z[ino].zoomy);
      line(x1+xe, y1+ye, x2+xe, y2+ye, 255, 255, 255, SET, z[ino].win);
   }
   for(j=1;j<=ysize/ny;j++)
   for(i=0;i<=xsize/nx;i++)
   {  x1 = ggg[0][j-1][i];
      x2 = ggg[0][j  ][i];
      y1 = ggg[1][j-1][i];
      y2 = ggg[1][j  ][i];
      x1 = cint((double)x1 * z[ino].zoomx);
      x2 = cint((double)x2 * z[ino].zoomx);
      y1 = cint((double)y1 * z[ino].zoomy);
      y2 = cint((double)y2 * z[ino].zoomy);
      line(x1+xe,y1+ye,x2+xe,y2+ye,255,255,255,SET,z[ino].win);
   }
   g.inmenu--;
}


//-------------------------------------------------------------------------//
// remap_coordinates                                                       //
//-------------------------------------------------------------------------//
void remap_coordinates(int ino, int f, int newino, int ***grid, int gridx1,
     int gridy1, int gridx2, int gridy2, int nx, int ny)
{
   if(!in_warp) return;
   if(!between(ino, 1, g.image_count-1)) return; 
   if(!between(newino, 1, g.image_count-1)) return; 
   if(ino==newino){message("No result image"); return;}
   int b,bpp,i,j,k,l,v,x,y,x1,y1,x2,y2,x3,y3,x4,y4;
   int xsrc,ysrc;
   int xsize = z[ino].xsize;
   int ysize = z[ino].ysize;
   double dx,dy,xa,xb,ya,yb; 
   uchar* address;
   bpp = z[ino].bpp;
   b = g.off[bpp];

   for(j=gridy1; j<gridy2; j++)
   for(i=gridx1; i<gridx2; i++)
   {  
       x1 = grid[0][j  ][i  ];  y1 = grid[1][j  ][i  ]; 
       x2 = grid[0][j  ][i+1];  y2 = grid[1][j  ][i+1]; 
       x3 = grid[0][j+1][i  ];  y3 = grid[1][j+1][i  ]; 
       x4 = grid[0][j+1][i+1];  y4 = grid[1][j+1][i+1];   // 4 closest grid pts.
       for(l=0; l<ny; l++)
       for(k=0; k<nx; k++)
       {
            x = min(xsize-1, k + i*nx);     // Destination coordinates 
            y = min(ysize-1, l + j*ny);
       
            xb = (double)k / nx;    // x fractional offset of point in box 
            yb = (double)l / ny;    // y fractional offset of point in box 
            xa = 1 - xb;
            ya = 1 - yb;

            dx = ya * (xa*(x1-x) + xb*(x2-x)) +
                 yb * (xa*(x3-x) + xb*(x4-x));

            dy = xa * (ya*(y1-y) + yb*(y3-y)) +
                 xb * (ya*(y2-y) + yb*(y4-y));
             
            xsrc = x - (int)dx;     // Source coordinates
            ysrc = y - (int)dy; 
            if(between(xsrc,0,xsize-2) && between(ysrc,0,ysize-2))
               v = pixelat(z[ino].image[f][ysrc] + xsrc*b, bpp);
            else v=0;
            address = z[newino].image[0][y] + x*b;
            putpixelbytes(address, v, 1, bpp);
       }
   }
   printf("chi square = %g\n", chisquare(ino, newino));
}


//-------------------------------------------------------------------------//
// chisquare                                                               //
//-------------------------------------------------------------------------//
double chisquare(int ino1, int ino2)
{
    int x,y,n,bpp,v1,v2;
    double chisq=0;
    bpp = z[ino1].bpp;
    if(z[ino1].bpp != z[ino2].bpp) return 0;
    n = z[ino1].xsize * z[ino1].ysize;
    for(y=0; y<z[ino1].ysize; y++)
    for(x=0; x<z[ino1].xsize; x++)
    {    if(between(x, 0, z[ino1].xsize-1) &&
            between(y, 0, z[ino1].ysize-1) &&
            between(x, 0, z[ino2].xsize-1) &&
            between(y, 0, z[ino2].ysize-1))
         {   v1 = pixelat(z[ino1].image[0][y] + x*g.off[bpp], bpp);
             v2 = pixelat(z[ino2].image[0][y] + x*g.off[bpp], bpp);
             chisq += (v1 - v2) * (v1 - v2);
         }
    }
    chisq /= n;
    return(chisq);
}
